#include <cstdio>
#include <vector>
#include <queue>

#define f(i, n) 					for(int i = 0 ; i < (n); i ++)
#define ff(i, st, end)				for(int i = (st); i < (end); i ++)
#define fv(i, v)					for(int i = 0 ; i < (int)(v).size(); i ++)
#define fx(i, v)					for( typeof( (v).begin() it = (v).begin(); it != (v).end(); it ++ )
#define all(v)						(v).begin(), (v).end()

int N, M, K;
std::vector<std::pair<int, int> > g[500005];
int parent[500005];
int num[1000005], top = 0;
int len[500005];
int L[500005];
int first[500005];
int all[500005];
int cnt[500005];
int rmq[21][1000005];

void dfs(int st)
{
	first[st] = top;
	num[top ++] = st;
	fv(i, g[st])
	{
		parent[ g[st][i].first ] = st;
		L[ g[st][i].first ] = L[st] + 1;
		len[ g[st][i].first ] = g[st][i].second;
		dfs( g[st][i].first );
		num[top ++] = st;
	}
}

//int stack[1000005], topS = 0;
/*int start[500005];
std::queue<int> q;
void dfs(int st)
{
	num[top ++] = st;
	while( st >= 1 )
	{
		printf("%d %d\n", st, parent[st]);
		if( start[st] < int(g[st].size() - 1) )
		{
			parent[ g[st][ start[st] ].first ] = st;
			L[ g[st][ start[st] ].first  ] = L[st] + 1;
			len[ g[st][ start[st] ].first ] = g[st][ start[st] ].second;
			num[top ++] = g[st][ start[st] ].first;
			start[st] ++;
			st = g[st][ start[st] ].first;
		}
		else
		{
			st = parent[st];
			num[top ++] = st;
		}
	}
	
	
/*	q.push(st);
	first[st] = top;
//	num[top ++] = st;
	while( !q.empty() )
	{
		int cur = q.front(); q.pop();
		num[top ++] = cur;
		fv(i, g[cur])
		{
			parent[ g[cur][i].first ] = cur;
			L[ g[cur][i].first ] = L[cur] + 1;
			len[ g[cur][i].first ] = g[cur][i].second;
			q.push( g[cur][i].first );
			num[top ++] = g[cur][i].first;
			num[top ++] = cur;
		}
	}
} */

inline int energy(int from, int to)
{
	int res = 0;
	while(to != from)
	{
		res += len[to];
		to = parent[to];
	}
	return res;
}

void make()
{
	int level = 1;
	while( (1 << level) <= (N << 1) - 1 )	level ++;
//	printf("%d\n", level);
	f(i, top) rmq[0][i] = num[i];
	int dist = 1;
	ff(cur, 1, level + 1)
	{
		f(i, top - (1 << cur) + 1)
			if( L[ rmq[ cur - 1 ][i] ] < L[ rmq[cur - 1][i + dist] ] )
				rmq[cur][i] = rmq[ cur - 1 ][i];
			else
				rmq[cur][i] = rmq[ cur - 1 ][i + dist];
		dist <<= 1;
	}
//	f(i, level + 1){ f(j, top - (1 << i) + 1) printf("%d ", rmq[i][j]); printf("\n"); }
}

inline int LCA(int a, int b)
{
	a = first[a], b = first[b];
	if(a > b)	std::swap(a, b);
	int len = b - a + 1;
	int level = 0;
	while( (1 << level) <= len  )	level ++;
	level --;
//	printf("%d %d %d %d\n", a, b, level, b - (1 << level) + 1);
	if( L[ rmq[level][a] ] < L[ rmq[level][ b - (1 << level) + 1 ] ]  )
	{
//		printf("%d\n", rmq[level][a]);
		return rmq[level][a];
	}
	else
	{
//		printf("%d\n", rmq[level][b - (1 << level) + 1]);
		return rmq[level][ b - (1 << level) + 1 ];
	}
}

int main()
{
	scanf("%d %d %d", &N, &M, &K);
	f(i, M)
	{
		int p, q, r;
		scanf("%d %d %d", &p, &q, &r);
		g[p].push_back( std::make_pair( q, r ) );
	}
	parent[1] = -1;
	dfs(1);
//	f(i, top) printf("%d ", num[i]);	printf("\n");
//	ff(i, 1, N + 1) printf("%d ", first[i]);	printf("\n");
	
	make();
	f(i, K)
	{
		int cur;
		scanf("%d", &cur);
		f(j, cur)
		{
			scanf("%d", &all[j]);
			cnt[j] = 1;
		}
		int res = 0;
		while( cur != 1 )
		{
//			f(j, cur) printf("%d ", all[j]); printf("\n");
			int omgebasi = all[cur - 1];
			int low = 1;
			f(j, cur - 1)
			{
				int wtf = LCA( all[j], all[cur - 1] );
				if( L[wtf] > L[low] )	low = wtf;
			}
			if( cnt[ cur - 1 ] == 1 )
			{
//				printf("%d %d current & count\n", all[cur - 1], cnt[cur - 1]);
				res += energy( low, all[cur - 1] );
			}
			else
			{
//				printf("%d %d current & count\n", all[cur - 1], cnt[cur - 1]);
				res += cnt[cur - 1] * ( energy( low, all[cur - 1] ) >> 1 );
			}
			int pos = -1;
			f(j, cur - 1)	if( all[j] == low )	{ pos = j; break; }
			int bu = cnt[ cur - 1 ];
			if( pos != -1 )
			{
				cnt[pos] += bu;
				cur --;
			}
			else
			{
				for(int j = cur; j > 0; j --)
				{
					all[j] = all[j - 1];
					cnt[j] = cnt[j - 1];
				}
				all[0] = low;
				cnt[0] = bu;
//				printf("%d %d nfi\n", all[0], cnt[0]);
			}
//			printf("%d %d %d\n", low, omgebasi, res);
//			system("pause");
		}
		if( cnt[ cur - 1 ] == 1 )
			res += energy( 1, all[cur - 1] );
		else
		{
//			printf("%d %d current & count\n", all[cur - 1], cnt[cur - 1]);
			res += cnt[cur - 1] * ( energy( 1, all[cur - 1] ) >> 1 );
		}
//		if( one[0] == 0 )	res >>= 1;
		printf("%d\n", res);
	}
    return 0;
}
