#include <stdio.h>
#define maxN 100005

int vis[maxN];
char off[maxN];
int tree[2][maxN];
int n,m;

void push(int pos, int val, char w)
{
     while (pos<=n+1) {
           tree[w][pos] += val;
           pos += (pos&(-pos));
           }
}

int pop(int pos, char w)
{
    int res=0;
    while (pos>0) {
          res += tree[w][pos];
          pos -= (pos&(-pos));
          }
    return res;
}

void add(int pos, int val)
{
     int l,r;
     if (val > vis[pos]) {
        l=r=1;
        while (pos+r <= n && vis[pos+r] != val-r) {
              push(pos+r+1,val-r-vis[pos+r],0); vis[pos+r] = val-r;
              push(pos+r,-1-off[pos+r-1],1); off[pos+r-1] = -1;
              ++r;
              }
        while (pos-l >= 0 && vis[pos-l] != val-l) {
              push(pos-l+1,val-l-vis[pos-l],0); vis[pos-l] = val-l;
              push(pos-l+1,+1-off[pos-l],1); off[pos-l] = +1;
              ++l;
              }
        push(pos-l+1,+1-off[pos-l],1); off[pos-l  ] = +1;
        push(pos+r,-1-off[pos+r-1],1); off[pos+r-1] = -1;
        push(pos+1,val-vis[pos],0);    vis[pos] = val;
        }
     
     if (val < vis[pos]) {
        l=r=1;
        while (pos+r <= n && vis[pos+r] != val+r) {
              push(pos+r+1,val+r-vis[pos+r],0); vis[pos+r] = val+r;
              push(pos+r,+1-off[pos+r-1],1); off[pos+r-1] = +1;
              ++r;
              }
        while (pos-l >= 0 && vis[pos-l] != val+l) {
              push(pos-l+1,val+l-vis[pos-l],0); vis[pos-l] = val+l;
              push(pos-l+1,-1-off[pos-l],1); off[pos-l] = -1;
              ++l;
              }
        push(pos-l+1,-1-off[pos-l],1); off[pos-l  ] = -1;
        push(pos+r,+1-off[pos+r-1],1); off[pos+r-1] = +1;
        push(pos+1,val-vis[pos],0); vis[pos] = val;
        }
}

void query(int a, int b)
{
     int res;--b;--a;
     res = 2*(pop(b+1,0)-pop(a+1,0))+pop(b+1,1)-pop(a+1,1);
     if (res&1) printf("%.1lf\n",(double)res/2.0);
     else printf("%d\n",res/2);
}

int main()
{
    int i,a,b,c;
    scanf("%d%d",&n,&m);
    for (i=0;i<=n;++i) {
        if (i&1) {push(i+1,1,0); push(i+1,-1,1); vis[i] = 1; off[i] = -1;}
        else {push(i+1,0,0); push(i+1,+1,1); vis[i] = 0; off[i] = +1;}
        }
    for (i=0;i<m;++i) {
        scanf("%d%d%d",&a,&b,&c);
        if (a == 1) add(b,c);
        if (a == 2) query(b,c);
        }
    return 0;
}
